//  reg.cpp
//
//	registry stuff
//
//	Copyright (c) 2005,2006 N099
//
#include <windows.h>
#include <tchar.h>
#include "defs.h"
#include "reg.h"

// WXgǂݍ
void LoadRegistryInfo(CONFIG *conf)
{
	HKEY hKey;
	DWORD val;
	DWORD size = sizeof(DWORD);
	LONG ret;

	//
	ZeroMemory(conf, sizeof(CONFIG));

	//ftHgl̐ݒ
	conf->use_mmx = 1;
	conf->i_sample_pos = 2;
	conf->prefer_yv12 = 1;
	conf->req_buffers = 2;

	RegOpenKeyEx(REG_KEY, REG_SUBKEY, 0, KEY_READ, &hKey);

	//use MMX
	ret = RegQueryValueEx(hKey, _T("use_MMX"), NULL, NULL, (LPBYTE)&val, &size);
	if(ret == ERROR_SUCCESS){
		conf->use_mmx = (val) ? 1 : 0;
	}

	//I/P mode select
	ret = RegQueryValueEx(hKey, _T("mode_ip"), NULL, NULL, (LPBYTE)&val, &size);
	if(ret == ERROR_SUCCESS){
		if(1 == val) conf->mode_ip = 1;
		else if(2 == val) conf->mode_ip = 2;
		else conf->mode_ip = 0;
	}

	//interlace color sample position select
	ret = RegQueryValueEx(hKey, _T("i_sample_pos"), NULL, NULL, (LPBYTE)&val, &size);
	if(ret == ERROR_SUCCESS){
		if(0<val && val<4) conf->i_sample_pos = val;
	}

	//NV12 output check
	ret = RegQueryValueEx(hKey, _T("connect_nv12"), NULL, NULL, (LPBYTE)&val, &size);
	if(ret == ERROR_SUCCESS){
		conf->connect_nv12 = (val) ? 1 : 0;
	}

	//prefer YV12 input
	ret = RegQueryValueEx(hKey, _T("prefer_yv12"), NULL, NULL, (LPBYTE)&val, &size);
	if(ret == ERROR_SUCCESS){
		conf->prefer_yv12 = (val) ? 1 : 0;
	}

	//request buffers
	ret = RegQueryValueEx(hKey, _T("req_buffers"), NULL, NULL, (LPBYTE)&val, &size);
	if(ret == ERROR_SUCCESS){
		if(0<val && val<5) conf->req_buffers = val;
	}

	RegCloseKey(hKey);
}

//WXgɃZ[u
void SaveRegistryInfo(CONFIG &conf)
{
	HKEY hKey;
	DWORD dispo;

	if (RegCreateKeyEx(
			REG_KEY,
			REG_SUBKEY,
			0,
			REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString(_T("SaveRegistryInfo:Couldn't create REG_SUBKEY"));
		return;
	}

	//use MMX
	RegSetValueEx(hKey, _T("use_MMX"), 0, REG_DWORD, (LPBYTE)&conf.use_mmx, sizeof(DWORD));

	//I/P mode select
	RegSetValueEx(hKey, _T("mode_ip"), 0, REG_DWORD, (LPBYTE)&conf.mode_ip, sizeof(DWORD));

	//interlace color sample position select
	RegSetValueEx(hKey, _T("i_sample_pos"), 0, REG_DWORD, (LPBYTE)&conf.i_sample_pos, sizeof(DWORD));

	//NV12 output check
	RegSetValueEx(hKey, _T("connect_nv12"), 0, REG_DWORD, (LPBYTE)&conf.connect_nv12, sizeof(DWORD));

	//prefer YV12 input
	RegSetValueEx(hKey, _T("prefer_yv12"), 0, REG_DWORD, (LPBYTE)&conf.prefer_yv12, sizeof(DWORD));

	//request buffers
	RegSetValueEx(hKey, _T("req_buffers"), 0, REG_DWORD, (LPBYTE)&conf.req_buffers, sizeof(DWORD));


	RegCloseKey(hKey);
}

//MMX̌o
bool isMMXavailable(void)
{
	bool mmx = false;

	//mmxo
	__asm{
			mov eax, 1
			cpuid
			test edx, 00800000h
			jz no
	}
			mmx = true;
	__asm no:

	return mmx;
}
